//
//  ProfileSettingsPresenter.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/12/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import Foundation
import RxSwift
import RxCocoa

enum ProfileSettingsNavigationOption {
    case login
}

protocol ProfileSettingsWireframeInterface: WireframeInterface {
    func navigate(to option: ProfileSettingsNavigationOption)
    func detachProfileSettings()
}

protocol ProfileSettingsViewInterface: ViewInterface {
    var viewModels: BehaviorRelay<[ProfileSettingsCellType]> { get }
}

final class ProfileSettingsPresenter: ProfileSettingsPresenterInterface {
    
    let backTrigger = PublishRelay<Void>()
    let logoutTrigger = PublishRelay<Void>()
    // MARK: - Private properties -
    private let disposeBag = DisposeBag()
    
    private unowned let view: ProfileSettingsViewInterface
    private let interactor: ProfileSettingsInteractorInterface
    private let wireframe: ProfileSettingsWireframeInterface
    
    // MARK: - Lifecycle -
    
    init(view: ProfileSettingsViewInterface, interactor: ProfileSettingsInteractorInterface, wireframe: ProfileSettingsWireframeInterface) {
        self.view = view
        self.interactor = interactor
        self.wireframe = wireframe
        
        configurePresenter()
        configureViewActions()
    }
}

// MARK: - Extensions -

extension ProfileSettingsPresenter {
    func configurePresenter() {
        Observable<[ProfileSettingsCellType]>.of([.logout])
            .bind(to: view.viewModels)
            .disposed(by: disposeBag)
    }
    
    func configureViewActions() {
        
        backTrigger
            .subscribeNext { [weak wireframe] in
                wireframe?.detachProfileSettings()
            }
            .disposed(by: disposeBag)
        
        logoutTrigger
            .doOnNext{ [weak wireframe] in
                wireframe?.navigate(to: .login)
            }
            .subscribeNext { [weak interactor] in
                interactor?.logout()
            }
            .disposed(by: disposeBag)
    }
}
